<template>
  <div :class="{ hidden: hidden }" class="pagination-container">
    <el-pagination
      :background="background"
      :current-page.sync="currentPage"
      :page-size.sync="pageSize"
      :layout="layout"
      :page-sizes="pageSizes"
      :pager-count="pagerCount"
      :total="total"
      v-bind="$attrs"
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
      style="padding: 20px; text-align: center"
    />
  </div>
</template>

<script>
import { scrollTo } from '@/utils/scroll-to'

export default {
  name: 'Pagination',
  props: {
    // 总条目数
    total: {
      required: true
      // type: Number
    },
    // 当前页
    page: {
      type: Number,
      default: 1
    },
    // 每页显示条目个数
    limit: {
      type: Number,
      default: 20
    },
    // 每页显示个数选择器的选项设置
    pageSizes: {
      type: Array,
      default() {
        return [10, 20, 30, 50]
      }
    },
    // 移动端页码按钮的数量端默认值5
    pagerCount: {
      type: Number,
      default: document.body.clientWidth < 992 ? 5 : 7
    },
    // 组件布局
    layout: {
      type: String,
      default: 'total, sizes, prev, pager, next, jumper'
    },
    // 是否为分页按钮添加背景色
    background: {
      type: Boolean,
      default: true
    },
    // 传递布尔值设置自动滚动到浏览器指定距离
    autoScroll: {
      type: Boolean,
      default: true
    },
    // 是否显示隐藏这个element分页组件
    hidden: {
      type: Boolean,
      default: false
    },
    // 改变element分页的'前往'文字
    changetotext: {
      type: String,
      default: ''
    }
  },
  computed: {
    // 当前页数
    currentPage: {
      get() {
        return this.page
      },
      set(val) {
        this.$emit('update:page', val)
      }
    },
    // 每页显示条目个数
    pageSize: {
      get() {
        return this.limit
      },
      set(val) {
        this.$emit('update:limit', val)
      }
    }
  },
  mounted() {
    if (this.changetotext) {
      this.pagingref(this.changetotext)
    }
  },
  methods: {
    // 每页显示条数发生变化时会触发
    handleSizeChange(val) {
      this.$emit('pagination', { page: this.currentPage, limit: val })
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    },
    // 当前页发生变化时会触发
    handleCurrentChange(val) {
      this.$emit('pagination', { page: val, limit: this.pageSize })
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    },
    // 改变分页文字方法
    pagingref(text) {
      document.getElementsByClassName('el-pagination__jump')[0].childNodes[0].nodeValue = text
    }
  }
}
</script>

<style scoped>
/* .pagination-container {
  background: #fff;
  padding: 32px 16px;
}
.el-pagination {
  right: auto;
  position: absolute;
} */
.pagination-container.hidden {
  display: none;
}
</style>
